<?php include('./templates/cabecera.php'); ?>
<?php include('./config/db.php'); ?>
<?php include('funciones.php'); ?>
<?php 
$html = "accesoInstalacion.php";
if(!$_GET){
    echo "<script>location.href='$html?pagina=1';</script>";
}

if($_SESSION['perfil'] == 2){
    echo "<script>location.href='index.php?pagina=1';</script>";
}

$error = "";
$txtFiltro=(isset($_GET['txtFiltro']))?$_GET['txtFiltro']:"";
$totalPaginas = 10;
$paginadorSalto = 9;
$instalacionId=0;
if(isset($_POST['chkActivo']) == "on"){
    $chkActivo = 1; //activo
}else{
    $chkActivo = 0; //inactivo
}
$txtId=(isset($_POST['txtId']))?$_POST['txtId']:"";
$selCliente=(isset($_POST['selCliente']))?$_POST['selCliente']:"";
$selInstalacion=(isset($_POST['selInstalacion']))?$_POST['selInstalacion']:"";
//print_r($selInstalacion);
//exit();

$txtNomUsuario=(isset($_POST['txtNomUsuario']))?$_POST['txtNomUsuario']:"";
$txtPassUsuario=(isset($_POST['txtPassUsuario']))?$_POST['txtPassUsuario']:"";
$txtPassUsuario2=(isset($_POST['txtPassUsuario2']))?$_POST['txtPassUsuario2']:"";
$action=(isset($_POST['action']))?$_POST['action']:"";

switch($action){
    case "Agregar":
        if($txtPassUsuario != $txtPassUsuario2){
            $error = $error."-La contrase&ntilde;as ingresadas deben ser iguales<br>";
            $txtPassUsuario = "";
        }
        if($selCliente == ""){
            $error = $error."-Debe seleccionar un cliente<br>";
        }
        if($selInstalacion == ""){
            $error = $error."-Debe seleccionar una instalación<br>";
        }
        if($txtNomUsuario == ""){
            $error = $error."-Debe ingresar un nombre<br>";
        }
        $txtNomUsuario = str_replace(" ","_",reestableceHTML($txtNomUsuario));
            try{
                $sql=$conexion->prepare("SELECT * FROM instalacionacceso where nombreUsuario LIKE :nombre;");  
                $sql->bindParam(":nombre",$txtNomUsuario);
                $sql->execute();
                if($sql->rowCount() > 0){
                    $error = $error."-El nombre de usuario ingresado ya se encuentra en nuestros registros<br>";
                }
            }catch (Exception $err) {
                echo ("Ha ocurrido un error en la solicitud. ");  
            }
        if(strlen($error) == 0){
            try{
                $txtPassUsuario = base64_encode($localBase."".$txtPassUsuario);
                $sql=$conexion->prepare("INSERT INTO instalacionacceso (activo, clienteId,nombreUsuario, contrasenna) 
                VALUES (:activo, :clienteId,:nombreUsuario,:contrasenna);");  
                $sql->bindParam(":activo",$chkActivo);
                $sql->bindParam(":clienteId",$selCliente);
                $sql->bindParam(":nombreUsuario",$txtNomUsuario);
                $sql->bindParam(":contrasenna",$txtPassUsuario);
                $sql->execute();
                $insFolio=0;
                $sql=$conexion->prepare("SELECT max(id) as id FROM instalacionacceso;"); 
                $sql->execute();
                $folio = $sql->fetch(PDO::FETCH_LAZY); //1 solo atributo, para trabajar con él
                $insFolio= $folio['id'];
                foreach($selInstalacion as $inst){
                    $instalacionId = $inst;
                    $sql=$conexion->prepare("INSERT INTO instalaciondetalleacceso (clienteId,instalacionId,idAcceso) 
                    VALUES (:clienteId,:instalacionId,:idAcceso);");  
                    $sql->bindParam(":clienteId",$selCliente);
                    $sql->bindParam(":instalacionId",$instalacionId);
                    $sql->bindParam(":idAcceso",$insFolio);
                    $sql->execute();
                }
                echo("<script>alert('Se ha ingresado el registro satisfactoriamente');</script>");
                echo "<script>location.href='$html';</script>";
            }catch (Exception $err) {
                $error = ("Ha ocurrido un error al agregar la solicitud");  
            }
        }
        break;
    case "Modificar":
            if($txtPassUsuario != $txtPassUsuario2){
                $error = $error."-La contrase&ntilde;as ingresadas deben ser iguales<br>";
                $txtPassUsuario = "";
            }
            if($selCliente == ""){
                $error = $error."-Debe seleccionar un cliente<br>";
            }
            if($selInstalacion == ""){
                $error = $error."-Debe seleccionar una instalación<br>";
            }
            if($txtNomUsuario == ""){
                $error = $error."-Debe ingresar un nombre<br>";
            }
            $txtNomUsuario = str_replace(" ","_",reestableceHTML($txtNomUsuario));
            try{
                $txtPassUsuario = base64_encode($localBase."".$txtPassUsuario);
                $sql=$conexion->prepare("UPDATE instalacionacceso SET activo=:activo, clienteId=:clienteId, 
                nombreUsuario=:nombreUsuario, contrasenna=:contrasenna where id=:id;");  
                $sql->bindParam(":id",$txtId);
                $sql->bindParam(":activo",$chkActivo);
                $sql->bindParam(":clienteId",$selCliente);
                $sql->bindParam(":nombreUsuario",$txtNomUsuario);
                $sql->bindParam(":contrasenna",$txtPassUsuario);
                $sql->execute();
                $sql=$conexion->prepare("delete from instalaciondetalleacceso where idAcceso=:id;");  
                $sql->bindParam(":id",$txtId);
                $sql->execute();
                foreach($selInstalacion as $inst){
                    $instalacionId = $inst;
                    $sql=$conexion->prepare("INSERT INTO instalaciondetalleacceso (clienteId,instalacionId,idAcceso) 
                    VALUES (:clienteId,:instalacionId,:idAcceso);");  
                    $sql->bindParam(":clienteId",$selCliente);
                    $sql->bindParam(":instalacionId",$instalacionId);
                    $sql->bindParam(":idAcceso",$txtId);
                    $sql->execute();
                }
                echo("<script>alert('Se ha modificado el registro satisfactoriamente');</script>");
                echo "<script>location.href='$html';</script>";
            }catch (Exception $err) {
                $error = ("Ha ocurrido un error al modificar la solicitud");  
            }
        break;
    case "Volver":
        echo "<script>location.href='index.php';</script>";
        break;
    case "Seleccionar":
        try{
            $sql=$conexion->prepare("SELECT * FROM instalacionacceso where id=:id;");  
            $sql->bindParam(":id",$txtId);
            $sql->execute();
            $Acceso = $sql->fetch(PDO::FETCH_LAZY); //1 solo atributo, para trabajar con él
            $txtId= $Acceso['id'];
            $chkActivo = $Acceso['activo']; 
            $selCliente= $Acceso['clienteId'];
            $txtNomUsuario= $Acceso['nombreUsuario'];
            $txtPassUsuario=str_replace($localBase,"",base64_decode($Acceso['contrasenna']));
        }catch (Exception $err) {
            $error = ("Ha ocurrido un error al seleccionar el registro"); 
        }
        break;
}

$sqlAccesoInstalacion="SELECT ia.id, ia.nombreUsuario, cli.nombre, cli.rut 
FROM instalacionacceso ia inner join cliente cli on cli.id=ia.clienteId ";  
if($txtFiltro!="" ){
    $sqlAccesoInstalacion = $sqlAccesoInstalacion . " where ia.nombreUsuario LIKE :id or cli.nombre LIKE :id or cli.rut LIKE :id";
}
try{
    $sql=$conexion->prepare($sqlAccesoInstalacion); 
    if($txtFiltro!="" ){
        $txtFiltro2=limpiaHTML("%".$txtFiltro."%");
        $sql->bindParam(":id",$txtFiltro2);
    }

    $sql->execute();
    if($sql->rowCount() > 0){
        $totalDatos = $sql->rowCount();
        $paginas = $totalDatos/$totalPaginas;
        $paginas = ceil($paginas);
    }else{
        $paginas = 1;
    }
}catch (Exception $err) {
    echo ("Ha ocurrido un error en la solicitud. ");    
    //throw $th;
}
if(is_null($_GET['pagina'])){
    $getPagina=0;
}else{
    $getPagina = intval($_GET['pagina']);
}

$iniciar = ($getPagina-1) * $totalPaginas;
$sqlAccesoInstalacion=$sqlAccesoInstalacion." ORDER BY id LIMIT :iniciar,:totalPaginas;";

try{
    $sql=$conexion->prepare($sqlAccesoInstalacion); 
    if($txtFiltro!="" ){
        $txtFiltro2=limpiaHTML("%".$txtFiltro."%");
        $sql->bindParam(":id",$txtFiltro2);
    }
    $sql->bindParam(":iniciar",$iniciar, PDO::PARAM_INT);
    $sql->bindParam(":totalPaginas",$totalPaginas, PDO::PARAM_INT);
    $sql->execute();
}catch (Exception $err) {
    echo ("Ha ocurrido un error en la solicitud. ");    
    //throw $err;
}
$listaAccesoInstalacion = $sql->fetchAll(PDO::FETCH_ASSOC); //almacena todos los registros como arreglo
?>
<script type="text/javascript">
	$(document).ready(function(){
        //recargaInstalacion(0,'');
		
        $('#selCliente').select2();
	})
</script>
<script type="text/javascript">
function recargaInstalacion(valor,usuario){
    idCliente = $('#selCliente').val();
    //alert(usuario);
    $.ajax({
        type:"POST",
        url:"asignaInstalacion.php",
        data:"clienteId=" + idCliente + "&seleccion="+valor+"&txtNomUsuario="+usuario,
        success:function(r){
            $('#select2lista').html(r);
            //$('#selInstalacion').select2();
        }
    });
}
</script>
<div class="col-md-4">
    <div class="card">
        <div class="card-header">
            <h4>Acceso clientes<h4/>
        </div>
        <div class="card-body">
                <?php if(strlen($error) > 0) {?>
                    <div class='alert alert-danger' role="alert">
                        <?php echo $error; ?>
                    </div>
                <?php }?>
            <form method="POST" enctype="multipart/form-data">
                <input type="hidden" class="form-control" name="txtId" id="txtId" value="<?php echo $txtId; ?>" >
                <div class="form-check form-switch">
                    <label for="chkActivo">Activo</label>
                    <input class="form-check-input" type="checkbox" id="chkActivo" name="chkActivo" <?php if($chkActivo == "1") {echo ("checked"); } ?>>
                </div>
                <div class = "form-group">
                    <label for="exampleSelect1" class="form-label mt-1">Cliente*</label>
                    <select required class="form-select" id="selCliente" name="selCliente" onchange="recargaInstalacion(0,0)">
                    <option value="">Seleccione</option>
                    <?php
                    try{
                    $sqlCliente=$conexion->prepare("SELECT id, nombre, rut FROM cliente where activo=1;");  
                    $sqlCliente->execute();
                    $listaCliente = $sqlCliente->fetchAll(PDO::FETCH_ASSOC); //almacena todos los registros como arreglo
                        foreach($listaCliente as $cli) { ?>
                            <option value="<?php echo $cli['id'] ?>" <?php if($selCliente==$cli['id']) {echo ("selected"); } ?>><?php echo $cli['nombre'] ?></option>
                        <?php 
                        } 
                    }catch (Exception $err) {
                        echo ("Ha ocurrido un error en la solicitud. ");    
                        throw $err;
                    }
                    ?>
                    </select>
                </div>
                <div class="form-group">
                    <label for="exampleSelect1" class="form-label mt-1">Instalaci&oacute;n*</label>
                    
                    <div id="select2lista" ></div>
                </div>
                <div class = "form-group">
                    <label for="exampleSelect1" class="form-label mt-1">Nombre usuario*</label>
                    <input type="text" required class="form-control" name="txtNomUsuario" id="txtNomUsuario" value="<?php echo $txtNomUsuario; ?>">
                </div>
                <div class = "form-group">
                    <label for="exampleSelect1" class="form-label mt-1">Contraseña*</label>
                    <input type="password" required class="form-control" name="txtPassUsuario" id="txtPassUsuario" value="<?php echo $txtPassUsuario; ?>">
                </div>
                <div class = "form-group">
                    <label for="exampleSelect1" class="form-label mt-1">Re-ingrese contraseña*</label>
                    <input type="password" required class="form-control" name="txtPassUsuario2" id="txtPassUsuario2" value="<?php echo $txtPassUsuario; ?>">
                </div>
                
                <br/>
                <div class="btn-group" role="group" aria-label="">
                    <button type="submit" name="action" <?php if ($action=="Seleccionar" or $action=="Modificar"  ){echo ("disabled");} ?> value="Agregar" class="btn btn-outline-success" onclick="return confirm('¿Está seguro de agregar el registro?')">Agregar</button> &nbsp;
                    <button type="submit" name="action" <?php if ($action!="Seleccionar" and $action!="Modificar"){echo ("disabled");} ?> value="Modificar" class="btn btn-outline-warning" onclick="return confirm('¿Está seguro de modificar el registro?')">Modificar</button>&nbsp;
                    <button type="submit" name="action" formnovalidate="" value="Volver" class="btn btn-outline-info">Volver</button>
                </div>
            </form>
        </div>
    </div>
</div>
<div class="col-md-8">
        <form class="d-flex" method="GET">
            <input type="hidden" class="form-control" name="pagina" id="pagina" value="<?php echo $getPagina; ?>" >
            <input class="form-control me-sm-2" type="text" placeholder="filtrar" name="txtFiltro" id="txtFiltro" value="<?php echo ($txtFiltro!="")?$txtFiltro:""; ?>">
            <button class="btn btn-outline-info" name="action" type="submit" value="Filtrar">Filtrar</button>
        </form>
    <table class="table table-hover">
        <thead>
            <tr>
                <th>ID</th>
                <th>Usuario</th>
                <th>Cliente</th>
                <th>RUT</th>
                <th>Acci&oacute;n</th>
            </tr>
        </thead>
        <tbody>
            <?php 
            foreach($listaAccesoInstalacion as $cli) { ?>
            <tr>
                <td><?php echo $cli['id'] ?></td>
                <td><?php echo $cli['nombreUsuario'] ?></td>
                <td><?php echo $cli['nombre'] ?></td>
                <td><?php echo $cli['rut'] ?></td>
                <td>
                    <form method="post">
                        <input type="hidden" name="txtId" id="txtId" value="<?php echo $cli['id'] ?>">
                        <!--input type="submit" name="action" value="Seleccionar" class="btn btn-outline-dark "-->
                        <button type="submit" name="action" class="btn btn-outline-dark" value="Seleccionar">
                            <i type="submit" class="bi bi-check2-circle" style="font-size: 1rem; color: #BA0700;"></i>
                        </button>
                    </form>
                </td>
            </tr>
            <?php } ?>
        </tbody>
    </table>
    <div>
        <ul class="pagination">
            <li class="page-item <?php echo ($getPagina<=1)?"disabled":""; ?>">
                <a class="page-link" href="<?php echo $html; ?>?pagina=<?php echo $getPagina-1 ?>&txtFiltro=<?php echo $txtFiltro; ?>">&laquo;</a>
            </li>
            <?php for($i=0; $i< $paginas; $i++ ) { 
                    if((($i+1)%$paginadorSalto)==0){
                        echo("</ul><ul class='pagination'>");
                    } 
                ?>
            <li class="page-item <?php echo ($getPagina==$i+1)?"active":""; ?>">
                <a class="page-link" href="<?php echo $html; ?>?pagina=<?php echo $i+1 ?>&txtFiltro=<?php echo $txtFiltro; ?>"><?php echo $i+1 ?></a>
            </li>
            <?php } ?>
            <li class="page-item <?php echo ($getPagina>=$paginas)?"disabled":""; ?>">
                <a class="page-link" href="<?php echo $html; ?>?pagina=<?php echo $getPagina+1 ?>&txtFiltro=<?php echo $txtFiltro; ?>">&raquo;</a>
            </li>
        </ul>
    </div>
</div>
<?php
if($action=="Seleccionar"){
    echo "<script>";
    echo "recargaInstalacion($txtId,'$txtNomUsuario');";
    echo "</script>";
}
?>
<?php include('./templates/pie.php'); ?>